##======================================
## ***  graph_xcs_cfc_funcs_Mux135.r   ***
##======================================

# options(warn=-1)

## IMA 3/27/2014
## 135-Bit Multiplexer - xcs_cfc_funcs
## This script will create a graph of the 135 bit multiplexer results and their standard deviation

## => Read a data file into a data variable:
df_dat_1 <- read.csv("/home/baotrung/coding/201905/ll.par.noloop.20200226/3788426_13.csv", colClasses=c("numeric", "numeric", "numeric"), sep=",")

## => Read the standard deviation file into a data variable:
#df_dev_1 <- read.delim("/vol/robotics-solar/Isidro/Data/IWCS_2014/xcs_cfc_funcs/135mux/ans_xcs_cfc_funcs_dev_Mux135.txt", colClasses=c("numeric", "numeric", "numeric", "numeric"), sep="")

## => Give the columns of the file just read some names:
names(df_dat_1)<-c("Instances","Performance","Errors")

## Add an index column to use as a reference
df_dat_1$Index <- c(1:10000)

## => Give the columns of the file just read some names:
#names(df_dev_1)<-c("Instances","Performance","Errors","Set_Size")

## Add an index column to use as a reference
#df_dev_1$Index <- c(1:5000)

## Now set set all the values to "Not Defined" unless it is the 
## 100th row 
## This will reduce the number of error bars on the graph
## otherwise it will be a mess.
#df_dev_1[df_dev_1$Index %% 100 > 0, ] <- NaN 

## => Draw the curve on the graph:
## Shows Title
# plot(df_dat135_1$Index ,df_dat135_1$Performance, type="l", lty=2, col="red", ylim=c(0.4,1), xlim=c(0, 5000), main = "135-Bit Multiplexer",xlab="Instances (x 1000)", ylab="Performance", lwd=2)
## No Title
g <- plot(df_dat_1$Index/4 ,df_dat_1$Performance, type="l", lty=2, col="red", ylim=c(0.4,1), xlim=c(0, 500), main = NULL, xlab="Instances (x 1000)", ylab="Performance", lwd=3)

## segments(x,y-sd,x,y+sd)
## Draw the vertical bar
#segments(df_dat135_1$Index, df_dat135_1$Performance - df_dev_1$Performance, df_dat135_1$Index, df_dat135_1$Performance + df_dev_1$Performance)

## Width of the horizontal bars
#epsilon <- 10

## Draw the horizontal bars
#segments(df_dat135_1$Index - epsilon, df_dat135_1$Performance - df_dev_1$Performance, df_dat135_1$Index + epsilon, df_dat135_1$Performance - df_dev_1$Performance)
#segments(df_dat135_1$Index - epsilon, df_dat135_1$Performance + df_dev_1$Performance, df_dat135_1$Index + epsilon, df_dat135_1$Performance + df_dev_1$Performance)


## *****************************************************************************
## 135-Bit Multiplexer - xcs_cfc_mux
## *****************************************************************************

## Don't erase previous curve.
#par(new=T)

## => Read a data file into a data variable:
#df_dat135_2 <- read.delim("/vol/robotics-solar/Isidro/Data/IWCS_2014/xcs_cfc_mux/135mux/ans_xcs_cfc_mux_avg_Mux135.txt", colClasses=c("numeric", "numeric", "numeric", "numeric"), sep="")

## => Read the standard deviation file into a data variable:
#df_dev_2 <- read.delim("/vol/robotics-solar/Isidro/Data/IWCS_2014/xcs_cfc_mux/135mux/ans_xcs_cfc_mux_dev_Mux135.txt", colClasses=c("numeric", "numeric", "numeric", "numeric"), sep="")

## => Give the columns of the file just read some names:
#names(df_dat135_2)<-c("Instances","Performance","Errors","Set_Size")

## Add an index column to use as a reference
#df_dat135_2$Index <- c(1:5000)

## => Give the columns of the file just read some names:
#names(df_dev_2)<-c("Instances","Performance","Errors","Set_Size")

## Add an index column to use as a reference
#df_dev_2$Index <- c(1:5000)

## Now set all the values to "Not Defined" unless it is the 
## 100th row 
## This will reduce the number of error bars on the graph
## otherwise it will be a mess.
#df_dev_2[df_dev_2$Index %% 100 > 0, ] <- NaN 

## => Draw the curve on the graph:
#plot(df_dat135_2$Index ,df_dat135_2$Performance, type="l", lty=3, col="blue", ylim=c(0.4,1), xlim=c(0, 5000), xlab="", ylab="", lwd=2)

#segments(x,y-sd,x,y+sd)
## Draw the vertical bar
segments(df_dat135_2$Index, df_dat135_2$Performance - df_dev_2$Performance, df_dat135_2$Index, df_dat135_2$Performance + df_dev_2$Performance)

## Draw the horizontal bars
segments(df_dat135_2$Index - epsilon, df_dat135_2$Performance - df_dev_2$Performance, df_dat135_2$Index + epsilon, df_dat135_2$Performance - df_dev_2$Performance)
segments(df_dat135_2$Index - epsilon, df_dat135_2$Performance + df_dev_2$Performance, df_dat135_2$Index + epsilon, df_dat135_2$Performance + df_dev_2$Performance)

## ================================================================================================================================
## Create a Legend

## Save default font
#savefont <- par(font=1, cex=0.7)
savefont <- par(font=1, cex=0.8)
 
## Draw a legend
legend_texts = expression( "[1] - 135-bits using XCSCF"^2, "[2] - 135-bits using XCSCFC  ")
 
#legend("bottomright", legend=c("[1] - 70-bits using XCS_CFC_FUNCS", "[2] - 70-bits using XCS_CFC_MUX"), 
## No Title
# legend("bottomright", legend = legend_texts, 
#	col=c("red","blue"), lty=c(2, 3), lwd=2)
## Shows Title
legend("bottomright", inset=0.01, title="135 Bit Multiplexer", legend = legend_texts, 
	col=c("red","blue"), lty=c(2, 3), lwd=2)

## Add some labels to the lines
## There is probably a much easier and better way to do this.
## Right now you have to click on each location for the labels.
text(locator(2), labels = c("[1]", "[2]"), adj=0)

## This will add some comments on the graph
# text(3200,0.7, "Note to reviewers: This is an average of 27 runs. ")  
# text(3200,0.65, "We are waiting for 30-27 runs which will be ")
# text(3200, 0.6, "added to the camera ready copy") 
# text(3200, 0.55, "if the paper is accepted.") 

## Restore default font
par(savefont) 

